<nav class="navbar navbar-expand-sm bg-light navbar-light">
  <div class="collapse navbar-collapse" id="navbarSupportedContent">
    <ul class="navbar navbar-nav mr-auto">
      <li class="nav-item">
        <button (click)="onGetAllProducts()" class="btn btn-outline-info ml-2">
          All
        </button>
      </li>
      <li class="nav-item">
        <button (click)="onGetSelectedProducts()" class="btn btn-outline-info ml-2">Selected</button>
      </li>
      <li class="nav-item">
        <button (click)="onGetAvailableProducts()" class="btn btn-outline-info ml-2">Available</button>
      </li>
      <li class="nav-item">
        <button (click)="onNewProduct()" class="btn btn-outline-info ml-2">New</button>
      </li>
    </ul>
    <form class="form-inline my-2 my-lg-0" #f="ngForm" (ngSubmit)="onSearch(f.value)">
      <input ngModel name="keyword" class="form-control mr-sm-2" type="search" placeholder="Search" aria-label="Search">
      <button class="btn btn-outline-success my-2 my-sm-0" type="submit">
        <span class="fa fa-search"></span>
      </button>
    </form>
  </div>
</nav>
<div class="container">

  <ng-container *ngIf="products$ | async as result" [ngSwitch]="result.dataState">
    <ng-container *ngSwitchCase="DataStateEnum.ERROR">
      <div class="alert-danger">
        {{ result.errorMessage }}
      </div>
    </ng-container>
    <ng-container *ngSwitchCase="DataStateEnum.LOADING"> Loading... </ng-container>
    <ng-container *ngSwitchCase="DataStateEnum.LOADED">
      <table class="table">
        <tr>
          <th>ID</th>
          <th>Name</th>
          <th>Price</th>
          <th>Quantity</th>
          <th>Selected</th>
          <th>Available</th>
        </tr>
        <tr *ngFor="let product of result.data">
          <td>{{ product.id }}</td>
          <td>{{ product.name }}</td>
          <td>{{ product.price }}</td>
          <td>{{ product.quantity }}</td>
          <td>{{ product.selected }}</td>
          <td>{{ product.available }}</td>
          <td>
            <button type="button" class="btn" [ngClass]="product.selected ? 'btn-success' : 'btn-danger'" (click)="onSelect(product)">
              <span *ngIf="product.selected">Unselect</span>
              <span *ngIf="!product.selected">Select</span>
            </button>
          </td>
          <td>
            <button class="btn btn-danger" (click)="onDelete(product)">
              <span class="fa fa-trash-o"></span>
            </button>
          </td>
          <td>
            <button class="btn btn-danger" (click)="onEditProduct(product)">
              <span class="fa fa-edit"></span>
            </button>
          </td>
        </tr>
      </table>
    </ng-container>
  </ng-container>
</div>
